<?php

namespace STM\Stadium;

use \Exception;
use STM\StmFactory;

/**
 * Test class for StadiumValidator.
 * Generated by PHPUnit on 2012-02-13 at 13:47:01.
 * @group team_stadium
 */
class StadiumValidatorTest extends \PHPUnit_Framework_TestCase {

    private $all_stadiums;
    
    protected function setUp() {
        StadiumValidator::init();
        $this->all_stadiums = StmFactory::find()->Stadium->findAll();
    }

    public function testCheck_create() {
        $this->assert_bad_arguments('checkCreate', null);
        $this->assert_bad_arguments('checkCreate', new Exception());
        $this->assert_bad_arguments('checkCreate', array('country' => 'a'));
        parent::assertTrue(StadiumValidator::checkCreate(array('name' => 'stadium', 'capacity' => 10, 'map_link' => 'www.seznam.cz', 'field_width' => '10m', 'field_height' => '5m')));
    }

    public function testCheck_update() {
        foreach ($this->all_stadiums as $stadium) {
            StadiumValidator::setStadium($stadium);
            $arr = $stadium->toArray();
            $valid = array(
                'name' => $stadium->__toString(),
                'capacity' => $arr['capacity'],
                'map_link' => $arr['map_link'],
                'field_width' => $arr['field_width'],
                'field_height' => $arr['field_height'],
            );
            // different from current values
            $this->assert_bad_arguments('checkUpdate', $valid);
            
            // at least one change (in name or club)
            $valid['name'] .= '*x*';
            parent::assertTrue(StadiumValidator::checkUpdate($valid));

            StadiumValidator::resetStadium();
        }
    }


    public function testCheck_name() {
        parent::assertTrue(StadiumValidator::checkName('stadium Nou Camp'));
        // string 2,60
        $this->assert_bad_arguments('checkName', null);
        $this->assert_bad_arguments('checkName', array());
        $this->assert_bad_arguments('checkName', new Exception());
    }

    public function testCheck_capacity() {
        parent::assertTrue(StadiumValidator::checkCapacity(95000));
        parent::assertTrue(StadiumValidator::checkCapacity('95000'));
        // string 1, 999999
        $this->assert_bad_arguments('checkCapacity', null);
        $this->assert_bad_arguments('checkCapacity', array());
        $this->assert_bad_arguments('checkCapacity', new Exception());
    }

    public function testCheck_map_link() {
        parent::assertTrue(StadiumValidator::checkMapLink('http:://www.seznam.cz'));
        parent::assertTrue(StadiumValidator::checkMapLink('http:://seznam.cz'));
        parent::assertTrue(StadiumValidator::checkMapLink('www.seznam.cz'));
        parent::assertTrue(StadiumValidator::checkMapLink('seznam.cz'));
        // links from maps
        parent::assertTrue(StadiumValidator::checkMapLink('http://g.co/maps/xnehs'));
        parent::assertTrue(StadiumValidator::checkMapLink('http://www.mapy.cz/s/33sh'));
        // string 4,150 && url address
        $this->assert_bad_arguments('checkMapLink', null);
        $this->assert_bad_arguments('checkMapLink', array());
        $this->assert_bad_arguments('checkMapLink', 'web');
    }

    public function testCheck_field_size() {
        parent::assertTrue(StadiumValidator::checkFieldSize(array('field_width' => '20', 'field_height' => '5')));        
        // array('field_width' => ..., 'field_height' => ...), string length 1-20
        $this->assert_bad_arguments('checkFieldSize', null);
        $this->assert_bad_arguments('checkFieldSize', array());
        $this->assert_bad_arguments('checkFieldSize', array('width' => '50', 'height' => '50'));
    }

    private function assert_bad_arguments($method, $data) {
        StadiumValidator::init();
        parent::assertFalse(StadiumValidator::$method($data));
        StadiumValidator::init();
    }
}

?>
